﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using EPiServer.Personalization.VisitorGroups;
using EPiServer.Web.Mvc.VisitorGroups;
using System.ComponentModel.DataAnnotations;

namespace CriteriaPack.WeatherCriterion
{
    public class WeatherCriterionModel : CriterionModelBase, IValidateCriterionModel
    {
        
        [Required]
        
        public string Weather { get; set; }

        [DojoWidget(SelectionFactoryType = typeof(EPiServer.Web.Mvc.VisitorGroups.EnumSelectionFactory), AdditionalOptions = "{ selectOnClick: true }")]
        public MatchStringType WeatherMatchType { get; set; }

        public override ICriterionModel Copy()
        {
            return base.ShallowCopy();
        }

        public CriterionValidationResult Validate(VisitorGroup currentGroup)
        {
            if (Weather.ToString().Length > 50)
            {
                return new CriterionValidationResult(false, "Invalid Weather!", "Weather");
            }

            return new CriterionValidationResult(true);
        }
    }

    
}
