﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Net;
using System.Xml;
using System.Web;
using System.Globalization;

namespace CriteriaPack.WeatherCriterion
{
    public class WeatherUtility
    {
        public static Weather GetCurrentWeather(string location)
        {
            HttpWebRequest GoogleRequest;
            HttpWebResponse GoogleResponse = null;
            XmlDocument GoogleXMLdoc = null;
            Weather currentWeather = new Weather();
            try
            {
                GoogleRequest = (HttpWebRequest)WebRequest.Create("http://www.google.com/ig/api?weather=" + string.Format(location));
                GoogleResponse = (HttpWebResponse)GoogleRequest.GetResponse();
                GoogleXMLdoc = new XmlDocument();
                GoogleXMLdoc.Load(GoogleResponse.GetResponseStream());

                XmlNode root = GoogleXMLdoc.DocumentElement;


                XmlNodeList nodeList1 = root.SelectNodes("weather/forecast_information");
                currentWeather.City = nodeList1.Item(0).SelectSingleNode("city").Attributes["data"].InnerText;

                XmlNodeList nodeList = root.SelectNodes("weather/current_conditions");
                currentWeather.Temperature = float.Parse(nodeList.Item(0).SelectSingleNode("temp_c").Attributes["data"].InnerText);
                currentWeather.Condition = nodeList.Item(0).SelectSingleNode("condition").Attributes["data"].InnerText;
                currentWeather.Wind = nodeList.Item(0).SelectSingleNode("wind_condition").Attributes["data"].InnerText;
                string sHumidity = nodeList.Item(0).SelectSingleNode("humidity").Attributes["data"].InnerText;


                currentWeather.Humidity = float.Parse(sHumidity.Split(":".ToCharArray())[1].Trim("%".ToCharArray()));
            }
            catch (System.Exception ex)
            {
                HttpContext.Current.Response.Write(ex.Message);
            }
            finally
            {
                GoogleResponse.Close();
            }
            return currentWeather;
        }

    }
}
